"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  default: () => unplugin_default
});
module.exports = __toCommonJS(src_exports);

// src/core/unplugin.ts
var import_node_events = __toESM(require("events"), 1);
var import_unplugin = require("unplugin");

// src/core/proxy.ts
var import_http_proxy = __toESM(require("http-proxy"), 1);

// src/core/json2ts.ts
var fs = __toESM(require("fs"), 1);
var import_json_to_ts = __toESM(require("json-to-ts"), 1);
var import_magic_string = __toESM(require("magic-string"), 1);
var import_change_case = require("change-case");
var import_utils = require("@imyangyong/utils");
var import_url_parse = __toESM(require("url-parse"), 1);
function parseUrl(req) {
  const parsedUrl = (0, import_url_parse.default)(req.url).pathname.split("/").map((name) => `${(name[0] || "").toUpperCase()}${name.slice(1)}`).join("");
  return `${req.method.toString().toUpperCase()}_${(0, import_change_case.pascalCase)(parsedUrl)}.d.ts`;
}
function isIgnore(req, ignore) {
  if (ignore) {
    const ignoreList = (0, import_utils.toArray)(ignore);
    for (const ignore2 of ignoreList) {
      if (ignore2.test(req.url))
        return true;
    }
  }
  return false;
}
function writeFileSyncRecursive(filename, content, charset = "utf-8") {
  let filepath = filename.replace(/\\/g, "/");
  let root = "";
  if (filepath[0] === "/") {
    root = "/";
    filepath = filepath.slice(1);
  } else if (filepath[1] === ":") {
    root = filepath.slice(0, 3);
    filepath = filepath.slice(3);
  }
  const folders = filepath.split("/").slice(0, -1);
  folders.reduce(
    (acc, folder) => {
      const folderPath = `${acc + folder}/`;
      if (!fs.existsSync(folderPath))
        fs.mkdirSync(folderPath);
      return folderPath;
    },
    root
    // first 'acc', important
  );
  fs.writeFileSync(root + filepath, content, charset);
}
var transformJSONToTs = (req, chunks, options) => {
  const {
    suffix = "ResponseType",
    encoding = "utf-8",
    rootDir = "@types",
    overwrite = true,
    declare = true,
    ignore = null
  } = options;
  if (isIgnore(req, ignore))
    return;
  const name = parseUrl(req);
  let dir = rootDir;
  if (rootDir.endsWith("/")) {
    const splitDir = rootDir.split("/");
    dir = splitDir.slice(0, splitDir.length - 1).join("");
  }
  dir = `${dir}/${name}`;
  const isFileExist = fs.existsSync(dir);
  if (overwrite || !isFileExist) {
    try {
      const json = JSON.parse(Buffer.concat(chunks).toString(encoding));
      const code = new import_magic_string.default((0, import_json_to_ts.default)(json).toLocaleString().replaceAll("},interface", "}\ninterface"));
      const typename = name.split("_");
      code.replace("interface RootObject", `${declare ? "declare" : "export"} interface ${typename[0]}${typename[1].replace(".d.ts", "")}${suffix}`);
      writeFileSyncRecursive(dir, code.toString());
    } catch (err) {
      console.log(`[proxy-json2ts Error] ${err}`);
    }
  }
};

// src/core/proxy.ts
var proxy = import_http_proxy.default.createProxyServer();
var chunksMap = /* @__PURE__ */ new Map();
var optionsMap = /* @__PURE__ */ new Map();
proxy.on("proxyRes", (proxyRes, req) => {
  chunksMap.set(req.url, []);
  proxyRes.on("data", (chunk) => {
    chunksMap.get(req.url).push(chunk);
  });
  proxyRes.on("end", () => {
    var _a;
    if ((_a = optionsMap.get(req.url)) == null ? void 0 : _a.json2ts)
      transformJSONToTs(req, chunksMap.get(req.url), optionsMap.get(req.url).json2ts);
  });
});
var proxyWeb = (req, res, option) => {
  optionsMap.set(req.url, option);
  proxy.web(req, res, __spreadValues({
    changeOrigin: true
  }, option));
};

// src/core/unplugin.ts
var ee = import_node_events.default.EventEmitter;
var unplugin_default = (0, import_unplugin.createUnplugin)((options) => {
  return {
    name: "unplugin-dev-proxy",
    vite: {
      configureServer(server) {
        ee.setMaxListeners(0);
        if (options) {
          for (const [route, option] of Object.entries(options.proxy)) {
            server.middlewares.use(route, (req, res) => {
              proxyWeb(req, res, option);
            });
          }
        }
      }
    }
  };
});
exports.default = module.exports;